//+------------------------------------------------------------------+
//|                                save all symbols periodically.mq4 |
//|                                   Copyright  2007, Serega Lykov |
//|                                       http://mtexperts.narod.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Serega Lykov"
#property link      "http://mtexperts.narod.ru/"
//#property show_confirm
#property show_inputs

extern int period = 600;   // interval of time in seconds

//+------------------------------------------------------------------+
//| "periodically to save all symbols"                               |
//+------------------------------------------------------------------+
int start()
{
int per = period*1000;
while(1==1)
  {
   int handle1 = FileOpenHistory("symbols.sel",FILE_BIN | FILE_READ);
   if(handle1<1)
     {
      Print("Error ! The file symbols.sel is not accessible.");
      return(false);
     }
   int handle2 = FileOpen("my_data.csv",FILE_CSV | FILE_WRITE,',');
   if(handle2<1)
     {
      Print("Error ! The file my_data.csv is not accessible.");
      FileClose(handle1);
      return(false);
     }
   int total = (FileSize(handle1)-4)/128;
   FileSeek(handle1,4,SEEK_SET);
   for(int i=0;i<total;i++)
     {
      string sym = FileReadString(handle1,6);
      FileWrite(handle2,sym,MarketInfo(sym,MODE_BID),MarketInfo(sym,MODE_ASK));
      FileSeek(handle1,122,SEEK_CUR);
     }
   FileClose(handle2);
   FileClose(handle1);
   Sleep(per);
  }
}
//+------------------------------------------------------------------+